/*-*-c++-*-*/
#include <vector>
#include <complex>
#include <string>
#include "calcpForEikrOverR.h"
#include "calcpForOneOverR.h"
#include "element.h"
#include "vector3D.h"

using namespace std;
using namespace pfft;

void 
setSrcPanelEvalPnt (
		    element& srcPanel,
		    vector<point3D>& evalPntVector,
		    vector<string>& evalPntDesList);

/**********************************************************************
 * main --
 **********************************************************************/
int
main (
      void)
{
  element srcPanel;
  vector<point3D> evalPntList;
  vector<string> evalPntDesList;
  setSrcPanelEvalPnt(srcPanel, evalPntList, evalPntDesList);

  bool needSlp = true;
  bool needDlp = true;
  bool needGradSlp = true;
  complex<double> K(0.);
  CalcpForEikrOverR<complex<double>, element> 
    calcp(K, FOLLOW_NORMAL_DIRECTION, needSlp, needDlp, needGradSlp, 24);

  complex<double> slp = 0;
  complex<double> dlp = 0;
  vector3D<complex<double> > gradSlp(0., 0., 0.);
  for (size_t i=0; i<evalPntList.size(); i++) {
    calcp(srcPanel, evalPntList[i], slp, dlp, gradSlp);
    cout << endl
	 << evalPntDesList[i] << endl
	 << "\tslp = " << slp << endl
	 << "\tdlp = " << dlp << endl
	 << "\tgradSlp = " << gradSlp;
  }
  return 1;
}

/**********************************************************************
 * setSrcPanelEvalPnt --
 **********************************************************************/
void 
setSrcPanelEvalPnt (
		    element& srcPanel,
		    vector<point3D>& evalPntVector,
		    vector<string>& evalPntDesList)
{
  double a = 0.5e-3;
  double b = 2*a;
  double h = a/2.;

  point3D v1(0., 0., 0.);
  point3D v2(a, 0., 0.);
  point3D v3(a, b, 0.);
  point3D v4(0., b ,0.);  
  srcPanel = element(v1, v2, v3, v4);

  evalPntVector.push_back(point3D(a/2, b/2, 0.)); 
  evalPntDesList.push_back(" center ");

  evalPntVector.push_back(point3D(1.5*a, b/2, 0.));
  evalPntDesList.push_back(" 1.5 side length away ");

  evalPntVector.push_back(point3D(a, b/2, 1.5*a));
  evalPntDesList.push_back(" above edge ");
}





